## rustc-1.88 1.88.0%2Bdfsg0ubuntu1

=== src/tools/enzyme/enzyme/test/ActivityAnalysis/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(check-activityanalysis "Running enzyme regression tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_TEST_DEPS}
    ARGS -v
)

set_target_properties(check-activityanalysis PROPERTIES FOLDER "Tests")

=== src/tools/enzyme/enzyme/test/BCLoader/CMakeLists.txt ===
# Run regression and unit tests
if (${Clang_FOUND})
add_lit_testsuite(check-bcpass "Running BCPass regression tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS BCPass-${LLVM_VERSION_MAJOR}
    ARGS -v
)

set_target_properties(check-bcpass PROPERTIES FOLDER "Tests")
endif()

=== src/tools/enzyme/enzyme/benchmarks/ReverseMode/ode-const/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(bench-odeconst-reverse "Running enzyme benchmarks tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_BENCH_DEPS}
    ARGS -v
)

=== src/tools/enzyme/enzyme/test/MLIR/ReverseMode/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(check-enzymemlir-reverse "Running MLIR reverse mode tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS enzymemlir-opt
    ARGS -v
)

set_target_properties(check-enzymemlir-reverse PROPERTIES FOLDER "Tests")

## rustc-1.88 1.88.0+dfsg0ubuntu1

=== vendor/r-efi-5.2.0/Makefile ===
#
# Maintenance Makefile
#

# Enforce bash with fatal errors.
SHELL			:= /bin/bash -eo pipefail

# Keep intermediates around on failures for better caching.
.SECONDARY:

# Default build and source directories.
BUILDDIR		?= ./build
SRCDIR			?= .

#
# Target: help
#

.PHONY: help
help:
	@# 80-width marker:
	@#     01234567012345670123456701234567012345670123456701234567012345670123456701234567
	@echo "make [TARGETS...]"
	@echo
	@echo "The following targets are provided by this maintenance makefile:"
	@echo
	@echo "    help:               Print this usage information"
	@echo
	@echo "    publish-github:     Publish a release to GitHub"

#
# Target: BUILDDIR
#

$(BUILDDIR)/:
	mkdir -p "$@"

$(BUILDDIR)/%/:
	mkdir -p "$@"

#
# Target: FORCE
#
# Used as alternative to `.PHONY` if the target is not fixed.
#

.PHONY: FORCE
FORCE:

#
# Target: publish-*
#

PUBLISH_REPO		?= r-efi/r-efi
PUBLISH_VERSION		?=

define PUBLISH_RELNOTES_PY
with open('NEWS.md', 'r') as f:
	notes = f.read().split("\n## CHANGES WITH ")[1:]
	notes = dict(map(lambda v: (v[:v.find(":")], v), notes))
	notes = notes["$(PUBLISH_VERSION)"].strip()
print("    # r-efi - UEFI Reference Specification Protocol Constants and Definitions\n")
print("    ## CHANGES WITH", notes)
endef

export PUBLISH_RELNOTES_PY
export PUBLISH_REPO
export PUBLISH_VERSION

.PHONY: publish-github
publish-github:
	test ! -z "$${PUBLISH_REPO}"
	test ! -z "$${PUBLISH_VERSION}"
	python \
		- \
		<<<"$${PUBLISH_RELNOTES_PY}" \
		| gh \
			release \
			--repo "$${PUBLISH_REPO}" \
			create \
			--verify-tag \
			--title \
			"r-efi-$${PUBLISH_VERSION}" \
			--notes-file - \
			"v$${PUBLISH_VERSION}"

=== src/tools/tidy/config/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.9
# by the following command:
#
#    pip-compile --generate-hashes --strip-extras src/tools/tidy/config/requirements.in
#
clang-format==18.1.7 \
    --hash=sha256:035204410f65d03f98cb81c9c39d6d193f9987917cc88de9d0dbd01f2aa9c302 \
    --hash=sha256:05c482a854287a5d21f7567186c0bd4b8dbd4a871751e655a45849185f30b931 \
    --hash=sha256:0b352ec51b291fe04c25a0f0ed15ba1a55b9c9c8eaa7fdf14de3d3585aef4f72 \
    --hash=sha256:217526c8189c18fd175e19bb3e4da2d1bdf14a2bf79d97108c9b6a98d9938351 \
    --hash=sha256:42d0b580ab7a45348155944adebe0bef53d1de9357b925830a59bbc351a25560 \
    --hash=sha256:57090c40a8f0a898e0db8be150a19be2551302d5f5620d2a01de07e7c9220a53 \
    --hash=sha256:607772cf474c1ebe0de44f44c1324e57a2d5b45a1d96d4aff166645532d99b43 \
    --hash=sha256:a49c44d7cc00431be8285aa120a7a21fa0475786c03c53b04a26882c4e626a43 \
    --hash=sha256:a62fca204293893badde0ab004df8b6df1d13eac4d452051554d9684d0a8254e \
    --hash=sha256:a914592a51f77c3563563c7a8970f19bc1ed59174ab992f095a78f4e142382ac \
    --hash=sha256:b3a0a09428cdd656ed87074543222a80660bc506407ed21b8e4bcb3d6d3a5a3c \
    --hash=sha256:c151d42e6ac7c3cc03d7fec61bed3211ce8f75528e1efd8fc64bdb33840987b2 \
    --hash=sha256:d6a2f051124d6ae506ba2a68accfe4ea4c8cb90d13b422c3131bb124413bac32 \
    --hash=sha256:f4f77ac0f4f9a659213fedda0f2d216886c410132e6e7dd4b13f92b34e925554 \
    --hash=sha256:f935d34152a2e11e55120eb9182862f432bc9789ab819f680c9f6db4edebf9e3
    # via -r src/tools/tidy/config/requirements.in
ruff==0.4.9 \
    --hash=sha256:06b60f91bfa5514bb689b500a25ba48e897d18fea14dce14b48a0c40d1635893 \
    --hash=sha256:0e8e7b95673f22e0efd3571fb5b0cf71a5eaaa3cc8a776584f3b2cc878e46bff \
    --hash=sha256:2d45ddc6d82e1190ea737341326ecbc9a61447ba331b0a8962869fcada758505 \
    --hash=sha256:4555056049d46d8a381f746680db1c46e67ac3b00d714606304077682832998e \
    --hash=sha256:5d5460f789ccf4efd43f265a58538a2c24dbce15dbf560676e430375f20a8198 \
    --hash=sha256:673bddb893f21ab47a8334c8e0ea7fd6598ecc8e698da75bcd12a7b9d0a3206e \
    --hash=sha256:732dd550bfa5d85af8c3c6cbc47ba5b67c6aed8a89e2f011b908fc88f87649db \
    --hash=sha256:784d3ec9bd6493c3b720a0b76f741e6c2d7d44f6b2be87f5eef1ae8cc1d54c84 \
    --hash=sha256:78de3fdb95c4af084087628132336772b1c5044f6e710739d440fc0bccf4d321 \
    --hash=sha256:8064590fd1a50dcf4909c268b0e7c2498253273309ad3d97e4a752bb9df4f521 \
    --hash=sha256:88bffe9c6a454bf8529f9ab9091c99490578a593cc9f9822b7fc065ee0712a06 \
    --hash=sha256:8c1aff58c31948cc66d0b22951aa19edb5af0a3af40c936340cd32a8b1ab7438 \
    --hash=sha256:98ec2775fd2d856dc405635e5ee4ff177920f2141b8e2d9eb5bd6efd50e80317 \
    --hash=sha256:b262ed08d036ebe162123170b35703aaf9daffecb698cd367a8d585157732991 \
    --hash=sha256:e0a22c4157e53d006530c902107c7f550b9233e9706313ab57b892d7197d8e52 \
    --hash=sha256:e91175fbe48f8a2174c9aad70438fe9cb0a5732c4159b2a10a3565fea2d94cde \
    --hash=sha256:f1cb0828ac9533ba0135d148d214e284711ede33640465e706772645483427e3
    # via -r src/tools/tidy/config/requirements.in

=== src/tools/enzyme/enzyme/BCLoad/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(BC_LOAD_FLAGS "" CACHE STRING "")
set(BC_LOAD_HEADER "" CACHE STRING "")

if (${LLVM_VERSION_MAJOR} EQUAL 15 OR ${LLVM_VERSION_MAJOR} EQUAL 16)
    set(BC_LOAD_FLAGS2 "${BC_LOAD_FLAGS} -Xclang -no-opaque-pointers")
else()
    set(BC_LOAD_FLAGS2 "${BC_LOAD_FLAGS}")
endif()

if (APPLE)
    set(BC_LOAD_FLAGS2 "${BC_LOAD_FLAGS2} --sysroot=${CMAKE_OSX_SYSROOT}")
endif()

if (NOT ("${BC_LOAD_HEADER}" STREQUAL ""))
    add_custom_target(blasheaders mkdir -p "${CMAKE_CURRENT_BINARY_DIR}/gsl" && cp ${BC_LOAD_HEADER} "${CMAKE_CURRENT_BINARY_DIR}/gsl/blas_headers.h")
set_target_properties(blasheaders PROPERTIES EXCLUDE_FROM_ALL TRUE)
elseif (${Clang_FOUND})
include(ExternalProject)
ExternalProject_Add(gsl
    GIT_REPOSITORY https://github.com/EnzymeAD/gsl
    GIT_TAG 5805b8323f75834c121fd65464cc55f2828f5b05
    PREFIX gsl
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/gsl/install
    CONFIGURE_COMMAND sh -c "cp sys/gsl_sys.h . && cp cblas/gsl_cblas.h . && rm cblas/test*.c && echo > config.h"
    BUILD_COMMAND  sh -c "rm cblas/xerbla.c && $<TARGET_FILE:clang> cblas/*.c ${BC_LOAD_FLAGS2} -I . -I .. -S -emit-llvm -O1"
    INSTALL_COMMAND ""
    UPDATE_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(gsl PROPERTIES EXCLUDE_FROM_ALL TRUE)

ExternalProject_Add(gsl64
    GIT_REPOSITORY https://github.com/EnzymeAD/gsl
    GIT_TAG 5805b8323f75834c121fd65464cc55f2828f5b05
    PREFIX gsl64
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/gsl64/install
    CONFIGURE_COMMAND sh -c ${CMAKE_CURRENT_SOURCE_DIR}/fixgsl64.sh
    BUILD_COMMAND  sh -c "rm cblas/xerbla.c && $<TARGET_FILE:clang> cblas/*.c ${BC_LOAD_FLAGS2} -I . -I .. -S -emit-llvm -O1"
    INSTALL_COMMAND ""
    UPDATE_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(gsl64 PROPERTIES EXCLUDE_FROM_ALL TRUE)


ExternalProject_Add(openblas
    GIT_REPOSITORY https://github.com/xianyi/OpenBLAS
    GIT_TAG 18b19d135b0e80219531219a90c1b78dd9249ad0
    PREFIX openblas
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/openblas/install
    CONFIGURE_COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/fixopenblas.sh $<TARGET_FILE:clang> 
    BUILD_COMMAND  sh -c "NO_CBLAS=1 GEMM_MULTITHREAD_THRESHOLD=4 COMMON_OPT=\"\" CC=\"$<TARGET_FILE:clang> -DDTB_DEFAULT_ENTRIES=64 -DGEMM_DEFAULT_ALIGN=\"0UL\" -DGEMM_DEFAULT_OFFSET_A=0 -DGEMM_DEFAULT_OFFSET_B=0 -DGEMM_P=0 -DGEMM_Q=0 -DGEMM_MULTITHREAD_THRESHOLD=4 -Dnthreads=1 -S -emit-llvm -O1\" AR=\"echo\" make -C interface VERBOSE=1 NUM_THREADS=1"
    INSTALL_COMMAND ""
    UPDATE_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(openblas PROPERTIES EXCLUDE_FROM_ALL TRUE)

ExternalProject_Add(fblas
    GIT_REPOSITORY https://github.com/EnzymeAD/clapack
    GIT_TAG 94f7c3118b7ce8267469457b17ede31ae88957a1
    PREFIX fblas
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/openblas/install
    CONFIGURE_COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/fixwrapblas.sh
    BUILD_COMMAND sh -c "$<TARGET_FILE:clang> ${BC_LOAD_FLAGS2} -S -emit-llvm -O1 BLAS/WRAP/bclib32.c BLAS/WRAP/bclib64.c -I ../../INCLUDE"
    INSTALL_COMMAND ""
    UPDATE_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(fblas PROPERTIES EXCLUDE_FROM_ALL TRUE)

add_custom_target(blasheaders cp "${CMAKE_CURRENT_SOURCE_DIR}/makeblas.cmake" "${CMAKE_CURRENT_BINARY_DIR}/gsl/CMakeLists.txt" && cd "${CMAKE_CURRENT_BINARY_DIR}/gsl" && ${CMAKE_COMMAND} . DEPENDS gsl gsl64 fblas ${CMAKE_CURRENT_SOURCE_DIR}/makeblas.cmake)
set_target_properties(blasheaders PROPERTIES EXCLUDE_FROM_ALL TRUE)
endif()

if ((NOT ("${BC_LOAD_HEADER}" STREQUAL "")) OR ${Clang_FOUND})
# on windows `PLUGIN_TOOL` doesn't link against LLVM.dll
if ((WIN32 OR CYGWIN) AND LLVM_LINK_LLVM_DYLIB)
    add_llvm_library( BCPass-${LLVM_VERSION_MAJOR}
        BCLoader.cpp ClangBCLoader.cpp
        MODULE
        DEPENDS
        intrinsics_gen
	LINK_COMPONENTS
	LLVM
    BUILDTREE_ONLY
    )
else()
    add_llvm_library( BCPass-${LLVM_VERSION_MAJOR}
        BCLoader.cpp ClangBCLoader.cpp
        MODULE
        DEPENDS
        intrinsics_gen
        PLUGIN_TOOL
        opt
        BUILDTREE_ONLY
    )
endif()

add_dependencies(BCPass-${LLVM_VERSION_MAJOR} blasheaders)
target_include_directories(BCPass-${LLVM_VERSION_MAJOR} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gsl)

if (APPLE)
# Darwin-specific linker flags for loadable modules.
set_target_properties(BCPass-${LLVM_VERSION_MAJOR} PROPERTIES
    LINK_FLAGS "-Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
endif()

set_target_properties(BCPass-${LLVM_VERSION_MAJOR} PROPERTIES EXCLUDE_FROM_ALL TRUE)

if (${ENZYME_EXTERNAL_SHARED_LIB})
    add_library( EnzymeBCLoad-${LLVM_VERSION_MAJOR}
        SHARED
        BCLoader.cpp 
    )
    add_dependencies(EnzymeBCLoad-${LLVM_VERSION_MAJOR} blasheaders)
    target_include_directories(EnzymeBCLoad-${LLVM_VERSION_MAJOR} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gsl)

    target_link_libraries(EnzymeBCLoad-${LLVM_VERSION_MAJOR} LLVM)
    install(TARGETS EnzymeBCLoad-${LLVM_VERSION_MAJOR}
        EXPORT EnzymeTargets
        LIBRARY DESTINATION lib COMPONENT shlib
        PUBLIC_HEADER DESTINATION "${INSTALL_INCLUDE_DIR}/Enzyme"
        COMPONENT dev)
endif()
endif()

=== src/tools/enzyme/enzyme/Enzyme/CMakeLists.txt ===
#if(WIN32 OR CYGWIN)
#  set(LLVM_LINK_COMPONENTS Core Support)
#endif()

if ("${Enzyme_TABLEGEN_EXE}" STREQUAL "")
  set(Enzyme_TABLEGEN_EXE enzyme-tblgen)
endif()

get_target_property(TBL_LINKED_LIBS LLVMSupport INTERFACE_LINK_LIBRARIES)
if (NOT TBL_LINKED_LIBS)
else()
list(REMOVE_ITEM TBL_LINKED_LIBS "ZLIB::ZLIB")
set_property(TARGET LLVMSupport PROPERTY INTERFACE_LINK_LIBRARIES ${TBL_LINKED_LIBS})
endif()

function(enzyme_tablegen ofn)
  tablegen(Enzyme ${ARGV})
  set(TABLEGEN_OUTPUT ${TABLEGEN_OUTPUT} ${CMAKE_CURRENT_BINARY_DIR}/${ofn}
      PARENT_SCOPE)
endfunction()

set(LLVM_TARGET_DEFINITIONS InstructionDerivatives.td)
enzyme_tablegen(BinopDerivatives.inc -gen-binop-derivatives)
enzyme_tablegen(IntrinsicDerivatives.inc -gen-intr-derivatives)
enzyme_tablegen(CallDerivatives.inc -gen-call-derivatives)
enzyme_tablegen(InstructionDerivatives.inc -gen-inst-derivatives)
enzyme_tablegen(BlasDerivatives.inc -gen-blas-derivatives)
enzyme_tablegen(BlasAttributor.inc -update-blas-declarations)
enzyme_tablegen(BlasTA.inc -gen-blas-typeanalysis)
enzyme_tablegen(BlasDiffUse.inc -gen-blas-diffuseanalysis)
add_public_tablegen_target(BinopDerivativesIncGen)
add_public_tablegen_target(IntrinsicDerivativesIncGen)
add_public_tablegen_target(CallDerivativesIncGen)
add_public_tablegen_target(InstructionDerivativesIncGen)
add_public_tablegen_target(BlasDerivativesIncGen)
add_public_tablegen_target(BlasDeclarationsIncGen)
add_public_tablegen_target(BlasTAIncGen)
add_public_tablegen_target(BlasDiffUseIncGen)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LLVM_LINK_COMPONENTS Demangle)

file(GLOB ENZYME_SRC CONFIGURE_DEPENDS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    "*.cpp"
)
list(REMOVE_ITEM ENZYME_SRC "eopt.cpp")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

list(APPEND ENZYME_SRC TypeAnalysis/TypeTree.cpp TypeAnalysis/TypeAnalysis.cpp TypeAnalysis/TypeAnalysisPrinter.cpp TypeAnalysis/RustDebugInfo.cpp)

if (ENZYME_ENABLE_PLUGINS)
        # on windows `PLUGIN_TOOL` doesn't link against LLVM.dll
        if ((WIN32 OR CYGWIN) AND LLVM_LINK_LLVM_DYLIB)
            add_llvm_library( LLVMEnzyme-${LLVM_VERSION_MAJOR}
                ${ENZYME_SRC}
                PARTIAL_SOURCES_INTENDED
                MODULE
                DEPENDS
                intrinsics_gen
        	LINK_COMPONENTS
        	LLVM
            )
            if (${Clang_FOUND})
                add_llvm_library( ClangEnzyme-${LLVM_VERSION_MAJOR}
                    ${ENZYME_SRC} Clang/EnzymeClang.cpp
                    Clang/EnzymePassLoader.cpp
                    PARTIAL_SOURCES_INTENDED
                    MODULE
                    DEPENDS
                    intrinsics_gen
            	LINK_COMPONENTS
            	LLVM
                )
                    target_compile_definitions(ClangEnzyme-${LLVM_VERSION_MAJOR} PUBLIC ENZYME_RUNPASS)
            endif()
                    add_llvm_library( LLDEnzyme-${LLVM_VERSION_MAJOR}
                    ${ENZYME_SRC} Clang/EnzymePassLoader.cpp
                    PARTIAL_SOURCES_INTENDED
                    MODULE
                    DEPENDS
                    intrinsics_gen
            	LINK_COMPONENTS
            	LLVM
                )
            target_compile_definitions(LLDEnzyme-${LLVM_VERSION_MAJOR} PUBLIC ENZYME_RUNPASS)
        else()
             add_llvm_library( LLVMEnzyme-${LLVM_VERSION_MAJOR}
                 ${ENZYME_SRC}
                 PARTIAL_SOURCES_INTENDED
                 MODULE
                 DEPENDS
                 intrinsics_gen
                 PLUGIN_TOOL
                 opt
             )
             if (${Clang_FOUND})
                 add_llvm_library( ClangEnzyme-${LLVM_VERSION_MAJOR}
                     ${ENZYME_SRC} Clang/EnzymeClang.cpp
                     Clang/EnzymePassLoader.cpp
                     PARTIAL_SOURCES_INTENDED
                     MODULE
                     DEPENDS
                     intrinsics_gen
                     PLUGIN_TOOL
                     clang
                 )
             target_compile_definitions(ClangEnzyme-${LLVM_VERSION_MAJOR} PUBLIC ENZYME_RUNPASS)
             endif()
                 add_llvm_library( LLDEnzyme-${LLVM_VERSION_MAJOR}
                     ${ENZYME_SRC} Clang/EnzymePassLoader.cpp
                     PARTIAL_SOURCES_INTENDED
                     MODULE
                     DEPENDS
                     intrinsics_gen
                     PLUGIN_TOOL
                     opt
                 )
             target_compile_definitions(LLDEnzyme-${LLVM_VERSION_MAJOR} PUBLIC ENZYME_RUNPASS)
        endif()
endif()

if (${ENZYME_STATIC_LIB})
    add_llvm_library( EnzymeStatic-${LLVM_VERSION_MAJOR}
        ${ENZYME_SRC}
        PARTIAL_SOURCES_INTENDED
        STATIC
        DEPENDS
        intrinsics_gen
    )
endif()

if (${ENZYME_EXTERNAL_SHARED_LIB})
    add_library( Enzyme-${LLVM_VERSION_MAJOR}
        SHARED
        ${ENZYME_SRC}
    )
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} intrinsics_gen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} BinopDerivativesIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} IntrinsicDerivativesIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} CallDerivativesIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} InstructionDerivativesIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} BlasDerivativesIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} BlasDeclarationsIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} BlasTAIncGen)
    add_dependencies(Enzyme-${LLVM_VERSION_MAJOR} BlasDiffUseIncGen)
    target_link_libraries(Enzyme-${LLVM_VERSION_MAJOR} LLVM)
    install(TARGETS Enzyme-${LLVM_VERSION_MAJOR}
        EXPORT EnzymeTargets
        LIBRARY DESTINATION lib COMPONENT shlib
        PUBLIC_HEADER DESTINATION "${INSTALL_INCLUDE_DIR}/Enzyme"
        COMPONENT dev)
endif()

if (APPLE)
# Darwin-specific linker flags for loadable modules.
set_target_properties(LLVMEnzyme-${LLVM_VERSION_MAJOR} PROPERTIES
    LINK_FLAGS "-Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
if (ENZYME_ENABLE_PLUGINS)
if (${Clang_FOUND})
set_target_properties(ClangEnzyme-${LLVM_VERSION_MAJOR} PROPERTIES
        LINK_FLAGS "-Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
endif()
set_target_properties(LLDEnzyme-${LLVM_VERSION_MAJOR} PROPERTIES
        LINK_FLAGS "-Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
endif()
endif()

add_library(LLDEnzymeFlags INTERFACE)
target_compile_options(LLDEnzymeFlags INTERFACE -flto)
target_link_options(LLDEnzymeFlags INTERFACE "SHELL: -fuse-ld=lld")

target_link_options(LLDEnzymeFlags INTERFACE "SHELL: -Wl,-mllvm -Wl,-load=$<TARGET_FILE:LLDEnzyme-${LLVM_VERSION_MAJOR}>")
target_link_options(LLDEnzymeFlags INTERFACE "SHELL: -Wl,--load-pass-plugin=$<TARGET_FILE:LLDEnzyme-${LLVM_VERSION_MAJOR}>")

add_library(LLDEnzymeAssumeUnknownNoFree INTERFACE)
target_link_options(LLDEnzymeAssumeUnknownNoFree INTERFACE "SHELL: -Wl,-mllvm -Wl,-enzyme-assume-unknown-nofree=1")

add_library(LLDEnzymeLooseTypeFlags INTERFACE)
target_link_options(LLDEnzymeLooseTypeFlags INTERFACE "SHELL: -Wl,-mllvm -Wl,-enzyme-loose-types=1")

add_library(LLDEnzymePrintTypeFlags INTERFACE)
target_link_options(LLDEnzymePrintTypeFlags INTERFACE "SHELL: -Wl,-mllvm -Wl,-enzyme-print-type=1")

add_library(LLDEnzymePrintFlags INTERFACE)
target_link_options(LLDEnzymePrintFlags INTERFACE "SHELL: -Wl,-mllvm -Wl,-enzyme-print=1")

add_library(LLDEnzymeNoStrictAliasingFlags INTERFACE)
target_link_options(LLDEnzymeNoStrictAliasingFlags INTERFACE "SHELL: -Wl,-mllvm -Wl,-enzyme-strict-aliasing=0")

if (ENZYME_ENABLE_PLUGINS)
# this custom target exists to prevent CMake from incorrectly assuming that
# targets that link depend on LLDEnzyme-XX can be built at the same time or
# before LLDEnzyme-XX has finished.
add_custom_target(LLDEnzymeDummy "" DEPENDS LLDEnzyme-${LLVM_VERSION_MAJOR})
add_dependencies(LLDEnzymeFlags LLDEnzymeDummy)

add_library(ClangEnzymeFlags INTERFACE)
target_compile_options(ClangEnzymeFlags INTERFACE "-fplugin=$<TARGET_FILE:ClangEnzyme-${LLVM_VERSION_MAJOR}>")

# this custom target exists to prevent CMake from incorrectly assuming that
# targets that link depend on ClangEnzyme-XX can be built at the same time or
# before ClangEnzyme-XX has finished.
add_custom_target(ClangEnzymeDummy "" DEPENDS ClangEnzyme-${LLVM_VERSION_MAJOR})
add_dependencies(ClangEnzymeFlags ClangEnzymeDummy)

install(TARGETS LLDEnzymeFlags EXPORT EnzymeTargets)
install(TARGETS ClangEnzymeFlags EXPORT EnzymeTargets)

install(TARGETS LLVMEnzyme-${LLVM_VERSION_MAJOR}
    EXPORT EnzymeTargets
    LIBRARY DESTINATION lib COMPONENT shlib
    COMPONENT dev)

if (${Clang_FOUND})
install(TARGETS ClangEnzyme-${LLVM_VERSION_MAJOR}
    EXPORT EnzymeTargets
    LIBRARY DESTINATION lib COMPONENT shlib
    COMPONENT dev)
    install(DIRECTORY "${PROJECT_SOURCE_DIR}/include/enzyme" DESTINATION "include")
endif()
install(TARGETS LLDEnzyme-${LLVM_VERSION_MAJOR}
    EXPORT EnzymeTargets
    LIBRARY DESTINATION lib COMPONENT shlib
    COMPONENT dev)

endif()
    
if (ENZYME_MLIR)
    add_subdirectory(MLIR)
endif()

=== src/tools/enzyme/enzyme/benchmarks/CMakeLists.txt ===
include(ExternalProject)
ExternalProject_Add(adept2
    GIT_REPOSITORY https://github.com/rjhogan/Adept-2
    GIT_TAG 4dc3d72c25d120a80745c44599dc8602a4f8fdeb
    PREFIX adept2
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/adept2/install
    CONFIGURE_COMMAND autoreconf -i && ./configure --prefix=${CMAKE_CURRENT_BINARY_DIR}/adept2/install 
    UPDATE_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(adept2 PROPERTIES EXCLUDE_FROM_ALL TRUE)
ExternalProject_Add(tapenade
    URL ${CMAKE_CURRENT_SOURCE_DIR}/ADFirstAidKit.tar
    PREFIX tapenade
    BUILD_IN_SOURCE 1
    INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}
    CONFIGURE_COMMAND ""
    BUILD_COMMAND make adBinomial.o adBuffer.o adContext.o adProfile.o adStack.o
    INSTALL_COMMAND ""
    TEST_COMMAND      ""
)
set_target_properties(tapenade PROPERTIES EXCLUDE_FROM_ALL TRUE)

set(BENCH_FLAGS "-I${CMAKE_CURRENT_BINARY_DIR}/adept2/src/adept2/include -I${CMAKE_CURRENT_BINARY_DIR}/tapenade/src/tapenade")
set(BENCH_LINK "${CMAKE_CURRENT_BINARY_DIR}/tapenade/src/tapenade/adBuffer.o ${CMAKE_CURRENT_BINARY_DIR}/tapenade/src/tapenade/adStack.o -L${CMAKE_CURRENT_BINARY_DIR}/adept2/install/lib -ladept")
set(BENCH_LDPATH "${CMAKE_CURRENT_BINARY_DIR}/adept2/install/lib")
message("found bench flags: " ${BENCH_FLAGS})

configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
  MAIN_CONFIG
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
)

set(ENZYME_BENCH_DEPS LLVMEnzyme-${LLVM_VERSION_MAJOR} adept2 tapenade)

# Run regression and unit tests
add_lit_testsuite(bench-enzyme "Running enzyme benchmarks tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_BENCH_DEPS}
    ARGS -v -j 1
)

set_target_properties(bench-enzyme PROPERTIES FOLDER "bench Tests")

add_subdirectory(ReverseMode)

=== src/tools/enzyme/enzyme/test/CMakeLists.txt ===
configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
  MAIN_CONFIG
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
)

set(ENZYME_TEST_DEPS LLVMEnzyme-${LLVM_VERSION_MAJOR})

add_subdirectory(ActivityAnalysis)
add_subdirectory(TypeAnalysis)
add_subdirectory(Enzyme)
if (ENZYME_ENABLE_PLUGINS)
if (${Clang_FOUND})
add_subdirectory(Integration)
if (${LLVM_VERSION_MAJOR} GREATER_EQUAL 11)
add_custom_target(test-cmake COMMAND rm -rf ${CMAKE_CURRENT_BINARY_DIR}/test_cmake && mkdir ${CMAKE_CURRENT_BINARY_DIR}/test_cmake && cd ${CMAKE_CURRENT_BINARY_DIR}/test_cmake &&  ${CMAKE_COMMAND} -S ${CMAKE_CURRENT_BINARY_DIR}/test_cmake ${CMAKE_CURRENT_SOURCE_DIR}/test_find_package -DEnzyme_DIR=${CMAKE_BINARY_DIR} -DCMAKE_C_COMPILER=$<TARGET_FILE:clang> && ${CMAKE_COMMAND} --build ${CMAKE_CURRENT_BINARY_DIR}/test_cmake DEPENDS ClangEnzymeFlags LLDEnzymeFlags)
else()
add_custom_target(test-cmake COMMAND rm -rf ${CMAKE_CURRENT_BINARY_DIR}/test_cmake && mkdir ${CMAKE_CURRENT_BINARY_DIR}/test_cmake && cd ${CMAKE_CURRENT_BINARY_DIR}/test_cmake &&  ${CMAKE_COMMAND} -S ${CMAKE_CURRENT_BINARY_DIR}/test_cmake ${CMAKE_CURRENT_SOURCE_DIR}/test_find_package -DEnzyme_DIR=${CMAKE_BINARY_DIR} -DCMAKE_C_COMPILER=$<TARGET_FILE:clang> && ${CMAKE_COMMAND} --build ${CMAKE_CURRENT_BINARY_DIR}/test_cmake DEPENDS ClangEnzymeFlags)
endif()
endif()
endif()
if (ENZYME_IFX)
    add_subdirectory(Fortran)
endif()
add_subdirectory(BCLoader)
if (ENZYME_MLIR)
    add_subdirectory(MLIR)
endif()

=== src/tools/enzyme/enzyme/tools/CMakeLists.txt ===
add_subdirectory(enzyme-tblgen)

=== src/tools/enzyme/enzyme/Enzyme/MLIR/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_subdirectory(Analysis)
add_subdirectory(Dialect)
add_subdirectory(Interfaces)
add_subdirectory(Implementations)
add_subdirectory(Passes)
add_subdirectory(enzymemlir-translate)
get_property(dialect_libs GLOBAL PROPERTY MLIR_DIALECT_LIBS)
get_property(conversion_libs GLOBAL PROPERTY MLIR_CONVERSION_LIBS)
set(LIBS
        ${dialect_libs}
        ${conversion_libs}
        MLIREnzymeAnalysis
        MLIREnzymeImplementations
        MLIREnzymeTransforms
        MLIREnzyme
        MLIROptLib
	MLIRFuncInlinerExtension
        )
add_llvm_executable(enzymemlir-opt enzymemlir-opt.cpp)

install(TARGETS enzymemlir-opt
    EXPORT EnzymeTargets
RUNTIME DESTINATION ${LLVM_TOOLS_INSTALL_DIR}
COMPONENT enzymemlir-opt)

llvm_update_compile_flags(enzymemlir-opt)
target_link_libraries(enzymemlir-opt PRIVATE ${LIBS})

=== src/tools/enzyme/enzyme/benchmarks/ReverseMode/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(bench-enzyme-reverse "Running enzyme benchmarks tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_BENCH_DEPS}
    ARGS -v -j 1
)

set_target_properties(bench-enzyme-reverse PROPERTIES FOLDER "bench Tests")

add_subdirectory(nn)
add_subdirectory(taylorlog)
add_subdirectory(logsumexp)
add_subdirectory(matdescent)
add_subdirectory(ode)
add_subdirectory(ode-const)
add_subdirectory(ode-real)
add_subdirectory(fft)

add_subdirectory(gmm)
add_subdirectory(ba)
add_subdirectory(hand)
add_subdirectory(lstm)

add_subdirectory(library)

=== src/tools/enzyme/enzyme/test/Fortran/CMakeLists.txt ===
add_subdirectory(ForwardMode)
add_subdirectory(ReverseMode)

# Run regression and unit tests
add_lit_testsuite(check-enzyme-fortran "Running enzyme fortran integration tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_TEST_DEPS} LLVMEnzyme-${LLVM_VERSION_MAJOR}
    ARGS -v
)

set_target_properties(check-enzyme-fortran PROPERTIES FOLDER "Tests")

=== src/tools/enzyme/enzyme/test/MLIR/CMakeLists.txt ===
add_subdirectory(ReverseMode)

# Run regression and unit tests
add_lit_testsuite(check-enzymemlir "Running MLIR regression tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS enzymemlir-opt
    ARGS -v
)

set_target_properties(check-enzymemlir PROPERTIES FOLDER "Tests")

=== src/tools/enzyme/enzyme/test/TypeAnalysis/CMakeLists.txt ===
# Run regression and unit tests
add_lit_testsuite(check-typeanalysis "Running enzyme regression tests"
    ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${ENZYME_TEST_DEPS}
    ARGS -v
)

set_target_properties(check-typeanalysis PROPERTIES FOLDER "Tests")

=== debian/changelog ===
rustc-1.88 (1.88.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.88.0 (LP: #2120340)
  * Standard maintenance:
    - debian/patches: Early-stage patch refresh
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
      dependencies of vendored crates
    - d/control,d/s/lintian-overrides: Update versioned identifiers
    - d/copyright: Update Files-Excluded with newly-pruned vendored crates
    - d/control,d/control.in: Update XS-Vendored-Sources-Rust
  * Drop unneeded patches:
    - d/p/upstream/u-fix-get-toml-when-test.patch: Fixed upstream
    - d/p/ubuntu/ubuntu-disable-ppc64el-asm-tests.patch: Failing tests were
      removed upstream
    - d/p/upstream/u-profiler-builtins-full-path.patch: Fixed upstream
    - d/p/upstream/u-run-make-support-dylib.patch: Fixed upstream
  * d/copyright: Update Files-Excluded list for new mdbook version
  * Fix bootstrap tests:
    - d/p/series,d/p/build/d-bootstrap-tests-restrict-defaults.patch: Restrict
      default config values for bootstrap tests
    - d/p/series,d/p/build/d-disable-git-bootstrap-tests.patch: Disable tests
      which require an upstream Git repo

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 22 Aug 2025 15:42:22 -0700

rustc-1.87 (1.87.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.87.0 (LP: #2118790)
  * Standard maintenance:
    - d/patches: Refresh patches
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
      dependencies of vendored crates
    - d/control,d/s/lintian-overrides: Update versioned identifiers
    - d/copyright: Update Files-Excluded with newly-pruned vendored crates
    - d/control,d/control.in: Update XS-Vendored-Sources-Rust
    - d/copyright: Update copyright stanzas
  * d/copyright: Remove src/tools/rls from Files-Excluded (dropped upstream)
  * Upgrade to LLVM 20:
    - d/p/ubuntu/ubuntu-enzyme-use-system-llvm.patch: Make LLVM_DIR llvm-20
    - d/rules,d/bin/rust-lld,d/control,d/*.in: Update LLVM references to
      version 20
  * Rename config.toml to bootstrap.toml:
    - d/copyright,d/rust-X.Y-src.install.in: Rename config.example.toml to
      bootstrap.example.toml
    - d/bootstrap.toml.in,d/prune-unused-deps,d/rules: Rename config.toml to
      bootstrap.toml
  * d/p/upstream/u-profiler-builtins-full-path.patch: Make profiler_builtins
    build script handle absolute path to profiler lib properly
  * Fix run-make test failures when rpath is disabled:
    - d/p/upstream/u-run-make-support-dylib.patch: Set rustc dylib path for
      run-make-support cargo wrapper
    - d/p/upstream/u-raw-rustc-command.patch: Add ability to get a raw
      rustc/rustdoc command for run-make tests

 -- Max Gilmour <max.gilmour@canonical.com>  Wed, 13 Aug 2025 13:36:27 -0700

rustc-1.86 (1.86.0+dfsg0ubuntu2-0ubuntu2) questing; urgency=medium

  * Remove vendored C libraries in favour of system libraries (LP: #2119556)
    - Repack orig tarball with unneeded vendored C libraries removed
    - d/control*,d/copyright,d/p/series: Use system libonig-dev instead of
      vendored oniguruma
    - d/config.toml.in,d/copyright,d/control,d/control.in: Use system
      libonig-sys instead of the vendored oniguruma
    - d/copyright,d/p/series: Use pure Rust impl of blake3 instead of the
      vendored C library

 -- Max Gilmour <max.gilmour@canonical.com>  Tue, 05 Aug 2025 14:30:47 -0700

rustc-1.86 (1.86.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.86.0 (LP: #2117513)
  * d/patches: Refresh patches
  * d/p/series: Remove unneeded libgit2 1.9 update patch
  * d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
    dependencies of vendored crates
  * d/p/series: Require SSE2 for the i386 baseline
  * d/copyright: Regenerate vendor Files-Excluded list
  * d/copyright: Add x.ps1 to Powershell script to Files-Excluded
  * d/copyright: Add files with missing copyright info
  * d/control,d/s/lintian-overrides: Update versioned control files
  * d/control,d/control.in: Update XS-Vendored-Sources-Rust
  * d/config.toml.in: Explicitly disable building vendored lld
  * d/p/upstream/u-mdbook-robust-chapter-path.patch: Stop mdbook panic on
    missing source path
  * d/p/prune/d-0000-ignore-removed-submodules.patch: Prune paths used to
    generate vendor copyright information
  * d/not-installed,d/not-installed.in: Ignore unnecessary licenses from Rust
    upstream
  * d/copyright housekeeping:
    - Restore alphabetical order of vendor copyright stanzas
    - Remove unneeded and redundant copyright stanzas
    - Remove unused licenses
  * d/p/upstream/u-powerpc-broken-f16-tests-workaround.patch: Cherry-pick
    upstream workaround for broken ppc64el f16 tests

 -- Max Gilmour <max.gilmour@canonical.com>  Tue, 22 Jul 2025 10:32:18 -0700

rustc-1.85 (1.85.1+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.85.1 (LP: #2109761)
  * d/patches: Refresh patches
  * d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
    dependencies for Rust 1.85
  * d/copyright: Update list of excluded source files after pruning
  * d/control,d/s/lintian-overrides: Re-generate files for rustc-1.85
  * d/patches: Refresh patches after pruning Windows sources
  * d/control,d/control.in: Update XS-Vendored-Sources-Rust
  * d/copyright: Add copyright entries for new dependencies
  * d/p/behaviour/d-rust-lldb-paths.patch: Update hardcoded lldb version
  * d/config.toml.in,d/copyright: Disable LLVM Enzyme
  * d/copyright: Exclude windows-bindgen metadata binaries

 -- Max Gilmour <max.gilmour@canonical.com>  Tue, 17 Jun 2025 11:15:23 -0700

rustc-1.84 (1.84.1+dfsg0ubuntu1-0ubuntu1) plucky; urgency=medium

  * New upstream version 1.84.1 (LP: #2097189)

 -- Zixing Liu <zixing.liu@canonical.com>  Fri, 31 Jan 2025 22:39:57 -0700

rustc-1.84 (1.84.0+dfsg0ubuntu1-0ubuntu1) plucky; urgency=medium

  * New upstream version 1.84.0 (LP: #2093796)


=== debian/control ===
Source: rustc-1.88
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.87 | cargo-1.88 <!pkg.rustc.dlstage0>,
 rustc-1.87 | rustc-1.88 <!pkg.rustc.dlstage0>,
 llvm-20-dev:native,
 llvm-20-tools:native,
 libclang-rt-20-dev (>= 1:20.1.2),
 libclang-common-20-dev (>= 1:20.1.2),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkgconf,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.9.0~~),
 libgit2-dev (<< 1.10~~),
 libhttp-parser-dev,
 libsqlite3-dev,
 libonig-dev,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-20:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 20
OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
# used by the upstream profiler build script
CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
# Clang per-target layout
export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
else
# Clang legacy layout
CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
ifeq ($(DEB_HOST_ARCH),armhf)
CLANG_RT_ARCH := armhf
endif
export LLVM_PROFILER_RT_LIB := /usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
endif
# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/bootstrap.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

# autopkgtest-related logic
ifneq (,$(RUST_TEST_SELFBUILD))
RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
endif

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_BOOTSTRAP_DIR))
        RUST_LIBRARY_PATH := $(RUST_BOOTSTRAP_DIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_BOOTSTRAP_DIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

# List generated files
FILES_TO_PRECONFIGURE := $(wildcard debian/*.in)
FILES_TO_PRECONFIGURE_OUT := $(subst X.Y,$(RUST_VERSION),\
  $(filter-out debian/control,\
    $(patsubst %.in,%,$(FILES_TO_PRECONFIGURE))\
  )\
)
DEFINED_SRC_NAME = $(shell dpkg-parsechangelog -S Source)
DEFINED_SRC_VERSION = $(shell cut -f1 -d' ' < $(CURDIR)/version)

%:
